/**
 * @module frest-json
 */
/**
 *    Copyright 2018 Panjie Setiawan Wicaksono
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */
import { IResponseInterceptor } from 'frest';
import { IJSONResponseInterceptorOption } from './types';
/**
 * Create a JSON response interceptor.
 *
 * @remarks
 * This interceptor will try to parse response's body if the response's
 * `Content-Type` header is compatible with the one provided in
 * {@link IJSONResponseInterceptorOption.headerContent} option.
 * If {@link IJSONResponseInterceptorOption.transform} is provided, it'll
 * call the function before parsing it.
 *
 * @param opts - Options for this response interceptor
 *
 * @returns JSON response interceptor
 */
export default function responseInterceptor(opts?: IJSONResponseInterceptorOption): IResponseInterceptor;
